(*****************************************************************************)
(*                                                                           *)
(*   Unit DOSALLOC.PAS v 1.00                                                *)
(*   Allows the user to fill DOS memory                                      *)
(*                                                                           *)
(*   1996 Carlos F de la Pen~a                                              *)
(*****************************************************************************)
unit DosAlloc;

interface
  function FillDosMemory: Pointer;
  procedure FreeDosMemory(PList: Pointer);

implementation
uses
  WinProcs;

const
  cSizeRec = 1024;

type
  PLongInt = ^LongInt;

function FillDosMemory: Pointer;
var
  Reserved1,
  Reserved2,
  ALongInt: LongInt;
  P,
  PList: PLongInt;
begin
  PList := nil;

  Reserved1 := GlobalDosAlloc(cSizeRec);
  Reserved2 := GlobalDosAlloc(cSizeRec);

  ALongInt := GlobalDosAlloc(cSizeRec);
  while (ALongInt <> 0) do
  begin
    P := PLongInt(ALongInt shl 16);
    P^ := LongInt(PList);
    PList := P;
    ALongInt := GlobalDosAlloc(cSizeRec);
  end;

  GlobalDosFree(LoWord(LongInt(Reserved1)));
  GlobalDosFree(LoWord(LongInt(Reserved2)));

  Result := PList;
end;

procedure FreeDosMemory(PList: Pointer);
var
  P,
  PGoodBye: PLongInt;
begin
  P := PList;
  while (P <> nil) do
  begin
    PGoodBye := P;
    P := PLongInt(P^);
    GlobalDosFree(SelectorOf(PGoodBye));
  end;
end;

END.
